import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;

import com.sun.xml.internal.bind.v2.schemagen.xmlschema.List;

public class LoadCSV {

	/*
	 * Right now we have just load class level metrics need to create a new load
	 * for methods and package level metrics
	 */

	private DatabaseLoader dataBaseLoader;

	public LoadCSV(DatabaseLoader dbLoader) {
		this.dataBaseLoader = dbLoader;
	}

	
	public String GetTableName(String FileName) {
		String tableName = "";
		if (FileName.contains("-bsm-extra-")) {
			tableName = "bsmExtra";
		} else if (FileName.contains("bsm-metrics-")) {
			tableName = "bsmMetrics";

		} else if (FileName.contains("data-jgn-grouped-main")) {
			tableName = "dataJgnGroupedMain";

		} else if (FileName.contains("data-jgn-main")) {
			tableName = "dataJgnMain";

		} else if (FileName.contains("data-jst-grouped-")) {
			tableName = "dataJstGrouped";

		} else if (FileName.contains("data-jst-")) {
			tableName = "dataJst";

		} else if (FileName.contains("dcf-main")) {
			tableName = "dcfMain";

		} else if (FileName.contains("extra-jgn")) {
			tableName = "extraJgn";

		} else if (FileName.contains("extra-jst")) {
			tableName = "extraJst";

		} else if (FileName.contains("impact-main")) {
			tableName = "impactMain";

		} else if (FileName.contains("-metrics-main-")) {
			tableName = "metricsMain";

		} else if (FileName.contains("-pmd-extra-2")) {
			tableName = "pmdExtra";

		} else if (FileName.contains("-pmd-metrics-grouped-")) {
			tableName = "pmdMetricsGrouped";
			
		} else if (FileName.contains("-pmd-metrics-")) {
			tableName = "pmdMetrics";

		} else if(FileName.contains(".txt")) {
			tableName = "qualityResults";
		}else{
			tableName ="NoTable";
		}

		return tableName;
	}

	public String buildInsertStatementHeader(String TableName, String[] headers) {
		String ovalue = "INSERT INTO " + TableName + " ( ";
		boolean first = true;
		for (String header : headers) {
			//Cleans up the header just in case
			header=header.replace("-","");
			header=header.replace(" ","");
			ovalue += header +" , ";

		}
		ovalue += "PackageName, Repository) VALUES( ";
		return ovalue;

	}
	public static String getPackageName(String fileName){
		String file = fileName.substring(0,fileName.lastIndexOf("/"));
		file = file.substring(0,file.lastIndexOf("/"));
		return file.substring(file.lastIndexOf("/")+1,file.length());
	}

	public void Loadfile(String fileName) throws Exception {
		//!GetTableName(fileName).equals("NoTable")

		FileReader fr = new FileReader(fileName);
		BufferedReader br = new BufferedReader(fr);
		String s;
		
		if (true) {
			int count = 1;
			String queryHeader = "";
			boolean alreadyDidHeaders =false;

			while ((s = br.readLine()) != null && !s.equals("")) {
				String[] headers;
				if (s.contains("Attribute Level Metrics")
						|| s.contains("Method Level Metrics")
						|| s.contains("Package Level Metrics")
						|| s.contains("Class Level Metrics")
						|| s.contains("CloneClass Level Metrics")
						|| s.contains("CloneInstance Level Metrics")
						|| s.contains("Interface Level Metrics")
						|| s.contains("LogicalView Level Metrics")
						|| s.contains("Sea Level Metrics")
						|| s.contains("Sea_lifted Level Metrics")) {
					headers = br.readLine().split(";");
					queryHeader = buildInsertStatementHeader(GetTableName(fileName),
							headers);
					s = br.readLine();
				} else if (fileName.contains("extra")&&!alreadyDidHeaders) {
					queryHeader = buildInsertStatementHeader(GetTableName(fileName),
							s.split(";"));
							s = br.readLine();
							alreadyDidHeaders = true;
				}
				
				String query ="";
				if(s!=null){
				String[] entries = s.split(";");
				for (String entry : entries) {
					query += "'" + entry + "', ";
				}

			
				String packageName = getPackageName(fileName);
				String repository = "";
				if(fileName.contains("cvs")){
					repository = "cvs";
				}
				else{
					repository ="svn";
				}
					
				// Cap the bracket
				query += "'" + packageName + "', ";
				query += "'" + repository  + "'";
				query += ")";
				dataBaseLoader.runQuery(queryHeader+query);
				count++;
			}
			}

			System.out.println(count);
			
		}
		/*else if(GetTableName(fileName).equals("qualityResults")){
			String query = "INSERT INTO qualityResults VALUES(";
			while ((s = br.readLine()) != null && !s.equals("")) {
				 query+= s.split(":")[1].trim()+",";
			}
			String packageName = getPackageName(fileName);
			query+="'"+packageName+"',";
			query+= "'"+(new Date()).toString()+"'"+")";
			dataBaseLoader.runQuery(query);
		}*/
		
		br.close();
		fr.close();
	}

}
